//go:build !disable_format_alac && enable_codec_libalac && cgo

package alac

import (
	"git.gammaspectra.live/S.O.N.G/Kirika/audio"
	"git.gammaspectra.live/S.O.N.G/Kirika/audio/format/flac"
	"git.gammaspectra.live/S.O.N.G/Kirika/test"
	"os"
	"testing"
)

func TestEncodeALAC(t *testing.T) {
	t.Parallel()
	fp, err := os.Open(test.SingleSample24)
	if err != nil {
		t.Error(err)
		return
	}
	defer fp.Close()
	source, err := flac.NewFormat().Open(fp)
	if err != nil {
		t.Error(err)
		return
	}

	target, err := os.CreateTemp("/tmp", "encode_test_*.m4a")
	if err != nil {
		t.Error(err)
		return
	}

	defer func() {
		name := target.Name()
		target.Close()
		os.Remove(name)
	}()

	options := make(map[string]interface{})
	options["bitdepth"] = 24

	err = NewFormat().Encode(source, target, options)
	if err != nil {
		t.Error(err)
		return
	}
}

func TestDecodeALAC(t *testing.T) {
	fp, err := os.Open(test.SingleSample24)
	if err != nil {
		t.Error(err)
		return
	}
	defer fp.Close()
	source, err := flac.NewFormat().Open(fp)
	if err != nil {
		t.Error(err)
		return
	}

	target, err := os.Open(test.SingleSampleALACMP4)
	if err != nil {
		t.Error(err)
		return
	}
	source, err = NewFormat().Open(target)
	if err != nil {
		t.Error(err)
		return
	}

	audio.NewNullSink().Process(source)
}
