//go:build !disable_format_flac && (disable_codec_libflac || !cgo)

package flac

import (
	"git.gammaspectra.live/S.O.N.G/Kirika/test"
	"os"
	"testing"
)

func TestEncodeFLAC(t *testing.T) {
	t.Parallel()
	fp, err := os.Open(test.SingleSample24)
	if err != nil {
		t.Error(err)
		return
	}
	defer fp.Close()
	source, err := NewFormat().Open(fp)
	if err != nil {
		t.Error(err)
		return
	}

	target, err := os.CreateTemp("/tmp", "encode_test_*.flac")
	if err != nil {
		t.Error(err)
		return
	}

	defer func() {
		name := target.Name()
		target.Close()
		os.Remove(name)
	}()

	err = NewFormat().Encode(source, target, nil)
	if err != nil {
		t.Error(err)
		return
	}
}
