//go:build cgo

package packetizer

/*
   #cgo CFLAGS: -march=native -Ofast -std=c99
   #include "ogg_crc.h"
*/
import "C"
import "runtime"

func oggCrc32(p []byte) uint32 {
	defer runtime.KeepAlive(p)
	return uint32(C.ogg_crc32((*C.uint8_t)(&p[0]), C.size_t(len(p))))
}
